// AIIntgrationTime.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <stdlib.h>


#include "../../../inc/bdaqadamio.h"
#include "../../../inc/compatibility.h"

//////////////////////////////////////////////
//Take ADAM-5017 for example
//Slot : 0
//Get/Set Integration time

//Note: You have mark the module definition or change slot index
uint16 iSlot = 0; 

int myprocHandle;

int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&myprocHandle) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle!=0)
		ADAMDrvClose(&myprocHandle);
}

static void showIntegrationTime()
{
	uint16  IntegrationTime = 0;
	uint32 ret = 0;
	
	ret = AI_GetRangeIntegrationTime(myprocHandle, iSlot, &IntegrationTime);
	if( ret == Success )
	{
		printf("AI_GetRangeIntegrationTime: \t\t%s\n",(IntegrationTime == 1 ? "50 Hz" : "60 Hz" ));
	}
	else
	{
		printf("AI_GetRangeIntegrationTime failed.ret = 0x%X\n",ret);
	}

}
static void setIntegrationTime()
{
	
	uint16  IntegrationTime = 0;
	uint32 ret = 0;
	
	printf("Enter IntegrationTime[0:60Hz,1:50Hz]:");
	scanf("%d",&IntegrationTime);
	
	ret = AI_SetRangeIntegrationTime(myprocHandle, iSlot, IntegrationTime);
	if( ret== Success)
	{
		printf("AI_SetRangeIntegrationTime done.\n" );
	}
	else
	{
		printf("AI_SetRangeIntegrationTime failed.ret = 0x%X\n",ret);
	}


}

int main(int argc, char* argv[])
{
	int iRet;
	bool bValue = false;
	bool setValue = true;

 	printf("/*** Intgration Time sample ***/ \n");
	printf("Select slotid: ");
	scanf("%d",&iSlot);

	iRet = OpenLib();
	if(iRet == Success)
	{
		showIntegrationTime();
		
		setIntegrationTime();
		
		showIntegrationTime();	
	}
	else
		printf("OpenLib(%d) failed.\n", iRet);

	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}

