// Adam5024.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <stdlib.h>

#include "../../../inc/bdaqadamio.h"
#include "../../../inc/compatibility.h"

//////////////////////////////////////////////
//Take ADAM-5024 for example
//Slot : 5

//Note: You have to change the slot index
//////////////////////////////slot index
uint16 iSlot = 0; 
//////////////////////////////////////// 

int m_iChTotal = 4;
//////////////////////////////////////////////


int myprocHandle;

int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&myprocHandle) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle != 0)
		ADAMDrvClose(&myprocHandle);
}

void GetValueRanges()
{
	double fVal;
	uint16 rawData;	
	uint8 byRange;
	int iChannel = 0;

	for(iChannel = 0;iChannel < m_iChTotal; iChannel++)
	{
		if(AO_GetValue(myprocHandle, iSlot, iChannel, &rawData, &fVal) == Success)
		{
			printf("AO%d : %f\n", iChannel, fVal);
			
			if(AO_GetOutputRange(myprocHandle, iSlot, iChannel, &byRange) == Success)
			{

				if(byRange == mA_0To20)
					printf("Range%d : %s\n", iChannel, "0~20mA");
				else if(byRange == mA_4To20)
					printf("Range%d : %s\n", iChannel, "4~20mA");
				else if(byRange == V_0To10)
					printf("Range%d : %s\n", iChannel, "0~10V");
				else
					printf("Range%d : %s(%X)\n", iChannel, "Unknown", byRange);
			}
			else
				printf("AO_GetOutputRange(ch%d) failed.\n", iChannel);
		}
		else
		{
			printf("AO_GetValue(ch%d) failed.\n", iChannel);
		}
	}
}

void SetValueRanges()
{
	double fVal;

	//BYTE byRange = mA_0To20;
	//BYTE byRange = mA_4To20;
	uint8 byRange = V_0To10;

	for(int iChannel = 0; iChannel < m_iChTotal; iChannel++)
	{
		if(AO_SetOutputRange(myprocHandle, iSlot, iChannel, byRange) == Success)
		{
			fVal = (float)(iChannel * 2);
			if(AO_SetValue(myprocHandle, iSlot, iChannel,NULL, &fVal) == Success)
			{
				printf("Set AO%d: %f\n", iChannel, fVal);
			}
			else
			{
				printf("AO_SetValue(ch%d) failed.\n", iChannel);
			}
		}
		else
			printf("AO_SetOutputRange(ch%d) failed.\n", iChannel);

	}
}

int main(int argc, char* argv[])
{
	int iRet;
 	printf("/*** Adam5024 Sample ***/ \n");
    
	printf("Select slotid: ");
	scanf("%d",&iSlot);
	
	iRet = OpenLib();
	if(iRet == Success)
	{
		printf("Get Current Status.\n");
		printf("========\n");
		GetValueRanges();
		printf("\n");
		
		//Change AO ranges and set AO values
		SetValueRanges();
		printf("\n");

		//Check result
		printf("Check Result.\n");
		printf("========\n");
		GetValueRanges();
		printf("\n");
	}
	else
		printf("OpenLib(%d) failed.\n", iRet);

	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}



