// Adam5081.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <stdlib.h>

#include "../../../inc/bdaqadamio.h"
#include "../../../inc/compatibility.h"

//////////////////////////////////////////////
//Take ADAM-5081 for example
//Get/Set Range, GetValues
 
//Note: You have to change the slot index
//////////////////////////////slot index
uint16 iSlot = 0;
//////////////////////////////////////// 

int m_iChTotal = 4;
//////////////////////////////////////////////

int myprocHandle;

int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&myprocHandle) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle!=0)
		ADAMDrvClose(&myprocHandle);
}

void GetAdam5081Range(uint8 i_byRange)
{
	if (i_byRange == 0)						
		printf("Bi_Direction\n");
	else if (i_byRange == 1)				
		printf("Up_Down\n");
	else if (i_byRange == 2)				
		printf("Up\n");
	else if (i_byRange == 3)				
		printf("Frequency\n");
	else if (i_byRange == 4)				
		printf("AB1X\n");
	else if (i_byRange == 5)				
		printf("AB2X\n");
	else if (i_byRange == 6)				
		printf("AB4X\n");
	else 
		printf("Unknown\n");
}

void GetRange()
{
	uint8 byRange;

	for(int iChannel=0;iChannel<m_iChTotal;iChannel++)
	{
		int ret = CNT_GetRange(myprocHandle, iSlot, iChannel, &byRange);
		if( ret == Success)
		{
			printf("Counter Mode:");
			GetAdam5081Range(byRange);
		}
		else
			printf("CNT_GetRange(ch%d) failed[%x].\n", iChannel,ret);
	}
}

void GetValues()
{
	uint32 lVal;

	for(int iChannel=0;iChannel<m_iChTotal;iChannel++)	
	{
		if(CNT_GetValue(myprocHandle, iSlot, iChannel, &lVal) == Success)
		{
			printf("Cnt%d : %u\n", iChannel, lVal);
		}
		else
		{
			printf("CNT_GetValue(ch%d) failed.\n", iChannel);
		}
	}
}

void SetRange()
{
	uint8 byRange = 2;	//for 5081 Up mode

	for(int iChannel=0;iChannel<m_iChTotal;iChannel++)	
	{
		if(CNT_SetRange(myprocHandle, iSlot, iChannel, byRange) == Success)
			printf("CNT_SetRange(ch%d) done.\n", iChannel);
		else
			printf("CNT_SetRange failed.\n");
	}
}

int main(int argc, char* argv[])
{
	int iRet;
	bool bValue = false;
	bool setValue = true;

 	printf("/*** Adam5081 Sample ***/ \n");
	printf("Select slotid: ");
	scanf("%d",&iSlot);

	iRet = OpenLib();
	if(iRet == Success)
	{
		//Get current channel status
		GetRange();
		GetValues();

		//Set channel range
		SetRange();

		//Check result
		GetRange();
		while(1)
		{
			GetValues();
			sleep(1);
		}
	}
	else
		printf("OpenLib(%d) failed.\n", iRet);

	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}
