// AdamAIBuffered.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <stdlib.h>

#include "../../../inc/bdaqadamio.h"
#include "../../../inc/compatibility.h"


//////////////////////////////////////////////

//Get/Set Range, Get/Set ChannelEnable, GetValues
//Note: You have mark the module definition or change slot index

//////////////////////////////slot index
uint16 iSlot = 0;
uint32 chStart = 0;
uint32 chCount = 1;
uint16 m_iChTotal = 8;
uint32 uRange = 0;

//////////////////////////////////////////////

int ADV_SUCCESS = 0;

int myprocHandle;

int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen_U(&myprocHandle, iSlot) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle!=0)
		ADAMDrvClose(&myprocHandle);
}

char * range2char(uint32 i_uRange)
{
	char *str = NULL;
	switch(i_uRange)
	{
	case V_Neg10To10:
		str = (char *)"V_Neg10To10";
		break;
	case V_Neg5To5:
		str = (char *)"V_Neg5To5";
		break;

	case V_Neg1To1:
		str = (char *)"V_Neg1To1";
		break;	
	case mV_Neg500To500:
		str = (char *)"mV_Neg500To500";
		break;	
	case mV_Neg150To150:
		str = (char *)"mV_Neg150To150";
		break;

	case mA_0To20:
		str = (char *)"mA_0To20";
		break;	

	default:
		str = (char *) "Unknown";
		break;
	}

	return str;
}

void setRanges()
{
	uint16 iChannel = 0;
	do
	{
		printf("Enter channel number[0~%d]:",m_iChTotal -1);
		scanf("%d",&iChannel);
		printf("Slot: %2u ,channel: %d\n",iSlot,iChannel);
	}
	while(iChannel < 0 || iChannel > (m_iChTotal -1));
	
	printf("%d):%s\n",V_Neg10To10,range2char(V_Neg10To10));
	printf("%d):%s\n",V_Neg5To5,range2char(V_Neg5To5));
	printf("%d):%s\n",V_Neg1To1,range2char(V_Neg1To1));
	printf("%d):%s\n",mV_Neg500To500,range2char(mV_Neg500To500));
	printf("%d):%s\n",mV_Neg150To150,range2char(mV_Neg150To150));
	
	printf("%d):%s\n",mA_0To20,range2char(mA_0To20));

	printf("Enter range number:");
	scanf("%d",&uRange);

	if(AI_SetInputRange(myprocHandle, iSlot, iChannel, uRange) == Success)
		printf("SetInputRange done.\n");
	else
		printf("SetInputRange failed.\n");
}
static void setChEnable()
{
	bool* bChEnabled = new bool[16];
	int en = 0;
	int iChannel=0;

	do
	{
		printf("Choose channel [0~%d]:", m_iChTotal-1);
		scanf("%d",&iChannel);
		printf("Slot: %2u ,channel: %d\n",iSlot,iChannel);
	}
	while(iChannel < 0 || iChannel > (m_iChTotal-1));

	if(AI_GetChannelEnabled(myprocHandle, iSlot, bChEnabled) == Success)
	{

		printf("enable or disable:");
		scanf("%d",&en);
		bChEnabled[iChannel] = (bool)en;

		if(AI_SetChannelEnabled(myprocHandle, iSlot, bChEnabled) == Success)
			printf("SetChannelEnabled(ch%d) : \t\t%d\n", iChannel, bChEnabled[iChannel]);

		else
			printf("SetChannelEnabled failed.\n");
	}
}
static void setSampleRate()
{
	int iChannel=0;
	uint16 sr = 10;
	
	printf("Enter sample rate( 10, 160, 640, 1000, 2000 ):");
	scanf("%d",&sr);

	if(AI_SetSampleRate(myprocHandle, sr) == Success)
		printf("SetSampleRate done.\n");
	else
		printf("SetSampleRate failed.\n");
}

static void showChEnable()
{
	bool* bChEnabled = new bool[16];

	if(AI_GetChannelEnabled(myprocHandle, iSlot, bChEnabled) == ADV_SUCCESS)
	{
		for(int iChannel=0; iChannel<m_iChTotal; iChannel++)
		{
			printf("ChannelEnabled(%d): \t\t%d\n", iChannel, bChEnabled[iChannel]);
		}
	}
	else
	{
		printf("GetChannelEnabled failed.\n");
	}
}

static void showValue()
{
	uint32 ret=0;
	//double fVal = 0.0;
	int iChannel = 0;
	double* fVal = new double[m_iChTotal];
	uint32* raw = new uint32[m_iChTotal];

	//for(iChannel = 0; iChannel < 2; iChannel++)
	{
		ret = AI_GetValues(myprocHandle, iSlot, raw, fVal);
		
		if( ret == Success)
		{
			for( iChannel = 0; iChannel < m_iChTotal; iChannel++)
			{
				printf("Value(ch%d)\t\t%f\t\t0x%X\n",iChannel,fVal[iChannel],raw[iChannel]);
			}
		}
		else
			printf("GetValues(ch%d) failed[%x].\n", iChannel,ret);
	}
}

static void showRange()
{
	uint32 ret=0;
	uint32 sVal;
	int iChannel = 0;
	
	for( iChannel = 0; iChannel < m_iChTotal; iChannel++)
	{
		ret = AI_GetInputRange(myprocHandle, iSlot, iChannel, &sVal);
		if( ret == Success)
		{
			printf("InputRange(ch%d): \t\t%u[ %s ]\n",iChannel,sVal , range2char(sVal));

		}
		else
			printf("GetInputRange(ch%d) failed[%x].\n", iChannel,ret);
	}
}
static void showSampleRate()
{
	uint16 usChSampleRate = 0;

	if(AI_GetSampleRate(myprocHandle, &usChSampleRate) == ADV_SUCCESS)
	{
		printf("SampleRate: \t\t%d\n",  usChSampleRate);
	}
	else
	{
		printf("GetSampleRate failed.\n");
	}
}
static void showStatus()
{
	uint32 ret=0;

	printf("slot: \t%d\n" ,iSlot);
	printf("================================================================\n");		
	showSampleRate();
	printf("================================================================\n");	
	showRange();
	printf("================================================================\n");		
	showValue();
	printf("================================================================\n");	
}
static int showMenu(int isClear)
{
	int max_item = 5;
	int value = 0;
	int ret = 0;
	if(isClear)
		system("clear");

	printf("slot:%d \n",iSlot);
	printf("0):exit\n");
	printf("1):set range\n");
	printf("2):set enable\n");
	printf("3):set sample rate\n");
	printf("4):display data\n");
	printf("5):BufferedAI mode\n");

	do{
		printf("enter item number[0~%d]:",max_item);
		scanf("%d",&value);
	}while(value < 0 || value > max_item);

	return value;
}
int main(int argc, char* argv[])
{
	int iRet;
	bool bValue = false;
	bool setValue = true;
	uint16 i_ch = 0;
	uint32 i = 0, j = 0;
	int dwWait = 0;
	int delayTime = 0;
	uint32 error = Success;
    uint32       rawDataSize = 0; // bytes per raw data
    void *      rawData = NULL;
    double * scaled_data = NULL;

    EventId    aiEventIds[] = {EvtBufferedAiOverrun,  EvtBufferedAiDataReady, EvtBufferedAiStopped,EvtBufferedAiCacheOverflow};
    HANDLE     aiEventHandles[4] = { NULL};
	uint32   dataCount = 1000;
    BOOL   bExit = false;
	uint32 chcntvalid = 0;
	bool* bChEnabled = new bool[16];
	FILE	* m_filech0=NULL;
	uint32 runmode = 0;
	uint32 totalcount = 0;
	
 	printf("/*** Adam BufferedAI Sample ***/ \n");
 	printf("Please select slot you want to run buffered ai:");
	scanf("%d", &iSlot );

	iRet = OpenLib();
	if(iRet != Success)
	{
		printf("OpenLib(%d) failed.\n", iRet);
		return 0;
	}
	showStatus();

	do{
			int ret = showMenu(0);

			switch(ret)
			{
			case 0:
				goto err;
				break;
			case 1:
				setRanges();
				showRange();
				break;
			case 2:
				setChEnable();
				showChEnable();
				break;
			case 3:
				setSampleRate();
				showSampleRate();
				break;
			case 4:
				do{
				showValue();
				printf("\nPress Enter back to maim menu\n");
				sleep(1);
				system("clear");}while(!kbhit());
				break;
			case 5:
				{
					system("clear");
					do{
						printf("Please select start channel(0~7):");
						scanf("%d", &chStart );
						printf("Please select channel count (1~8):");
						scanf("%d", &chCount );
					}while(chStart + chCount > m_iChTotal);

					printf("please set data count:");
					scanf("%d", &dataCount);

			 	    printf("/*** Start BufferedAI ***/ \n");
					printf("1) Run once.\n");
					printf("2) Run in cycle.\n");

					printf("Please select run mode:");
					scanf("%d", &runmode );

					error =AI_BfdAiPrepare(myprocHandle, chStart, chCount, dataCount, &rawData );
					if(BioFailed(error))
					{
					    printf("Buffer prepare error : 0x%X\n", error);
					    break;
					}

					for( i = 0; i < sizeof(aiEventIds)/sizeof(aiEventIds[0]); i++)
				    {
						error = AI_EventGetHandle(myprocHandle, aiEventIds[i], &aiEventHandles[i]);
						if(BioFailed(error))
						{
						     printf("EventGetHandle error : 0x%X\n", error);
						     break;
						}
						AI_EventClearFlag(myprocHandle, aiEventIds[i], 0, 0);

				    }
					switch(runmode)
					{
					case 1:
						{
							error =AI_BfdAiRunOnce(myprocHandle);
							if(BioFailed(error))
							{
								printf("Run once error : 0x%X\n", error);
							    break;
							}
						}
						break;
					case 2:
						{
							error =AI_BfdAiRun(myprocHandle );
							if(BioFailed(error))
							{
								printf("Run in cycle error : 0x%X\n", error);
							    break;
							}
							dataCount =  (dataCount > (125 * chCount)) ? ((dataCount / (125 * chCount)) * (125 * chCount)): (125 * chCount);
						}
						break;
					 default:
						break;
					}

					m_filech0=fopen( "DataCh0.txt","w+");

					if (!m_filech0)
						printf("Open File fail!\n");

					do{

						uint32   readyDataCount = 0;
						uint32   readyDataOffset = 0;   //unit in sample data
						uint32   channelOffset = 0;

						delayTime = 1000;

						dwWait = AI_WaitForMultipleObjects(myprocHandle,  4, aiEventHandles, false, delayTime);
						if(dwWait < 4 )//some AI event occurred
						{
							switch(aiEventIds[dwWait])
							{
							case EvtBufferedAiOverrun:
								printf("EvtBufferedAiOverrun occurred!\n offset is %d\n",readyDataOffset);
								bExit = true;
								break;
							case EvtBufferedAiCacheOverflow:
								printf("EvtBufferedAiCacheOverflow occurred!\n");
								bExit = true;
								break;
							case EvtBufferedAiDataReady:
								AI_EventGetLastStatus(myprocHandle, EvtBufferedAiDataReady, &readyDataCount, &readyDataOffset );
								//convert all newly ready data from raw data to scaled data, not necessary
								printf("EvtBufferedAiDataReady: +%d, %d samples.\n", readyDataOffset, readyDataCount);

								if(readyDataCount != 0)
								{
								    scaled_data = new double[readyDataCount];

									if(readyDataOffset + readyDataCount  > dataCount)
										readyDataCount = dataCount - readyDataOffset;

									AI_BfdAiScaleData(myprocHandle, (void *)((uint32 *)rawData + readyDataOffset) , scaled_data, readyDataCount, &channelOffset);

									for ( i = chStart; i < chStart + chCount; i++ )
										printf("CH[%d]: [0x%08X]\t\n", i, ((uint32*)rawData)[readyDataOffset + i - chStart] & 0xfffff);
									for ( i = 0; i < readyDataCount; i = i + chCount )
										fprintf(m_filech0 ,"Data[%d]: \t%d\t%f\n",totalcount+ i/chCount, ((uint32*)rawData)[readyDataOffset+i], scaled_data[i]);

									totalcount = totalcount + readyDataCount / chCount;
									//tell the driver how many data has been handled
									error = AI_EventClearFlag(myprocHandle, EvtBufferedAiDataReady,readyDataCount,0 );
									if(BioFailed(error))
									{
										bExit = true;
										break;
									}
									delete[] scaled_data;
								}
								printf("\n");
								break;

							case EvtBufferedAiStopped:
								AI_EventGetLastStatus(myprocHandle, EvtBufferedAiDataReady, &readyDataCount, &readyDataOffset );
								//convert all newly ready data from raw data to scaled data, not necessary
								printf("EvtBufferedAiDataReady: +%d, %d samples.\n", readyDataOffset, readyDataCount);
								if(readyDataCount != 0)
								{
								    scaled_data = new double[readyDataCount];
									AI_BfdAiScaleData(myprocHandle, (void *)((uint32 *)rawData + readyDataOffset) , scaled_data, readyDataCount, &channelOffset);

									for ( i = chStart; i < chStart + chCount; i++ )
										printf("CH[%d]: [0x%08X]\t\n", i, ((uint32*)rawData)[readyDataOffset + i - chStart]  & 0xfffff);
									for ( i = 0; i < readyDataCount; i = i + chCount )
										fprintf(m_filech0 ,"Data[%d]: \t%d\t%f\n",totalcount+ i/chCount, ((uint32*)rawData)[readyDataOffset+i], scaled_data[i]);

									totalcount = totalcount + readyDataCount / chCount;
									delete[] scaled_data;
								}
								error = AI_EventClearFlag(myprocHandle, EvtBufferedAiDataReady,readyDataCount,0 );
								if(BioFailed(error))
								{
									bExit = true;
									break;
								}
								AI_EventGetLastStatus(myprocHandle, EvtBufferedAiStopped, &readyDataCount, &readyDataOffset );
								printf("EvtBufferedAiStopped\n");
								error = AI_EventClearFlag(myprocHandle, EvtBufferedAiStopped,readyDataCount,0 );
								if(BioFailed(error))
								{
									bExit = true;
									break;
								}
								AI_BfdAiStop(myprocHandle);
								bExit = true;
								break;
							}
						}
						else if ( WAIT_TIMEOUT == dwWait )
						{
						  printf("Wait timeout.\n");
						}
						else if (WAIT_FAILED == dwWait   )
						{
						  printf("Wait failed.\n");
						  continue;
						}
						else
						{
						  printf("WaitForEvent Failed\n");
						  break;
						}
						if(kbhit())
						{
							error = AI_BfdAiStop(myprocHandle);
							if(BioFailed(error))
							    printf("Buffer stop error : 0x%X\n", error);
						}
					}while(!bExit);

					bExit = false;
					AI_BfdAiRelease(myprocHandle);
					fclose(m_filech0);
				}
				break;
			default:
				break;
			}
	}while(1);
err:
	CloseLib();
	printf("/***        END         ***/ \n");
	return 0;
}

