// AdamDI.cpp : Defines the entry point for the application.
//

#include <stdio.h>
#include <stdlib.h>
#include "../../../inc/bdaqadamio.h"

//using namespace Automation::BDAQDIO;

//////////////////////////////////////////////
//Take ADAM-5050 for example
//Slot : 0
//Reverse channel 0 value 
uint16 iSlot = 0; 
uint16 iChannel = 0;
//////////////////////////////////////////////

int myprocHandle;

int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&myprocHandle) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle!=0)
		ADAMDrvClose(&myprocHandle);
}

int main(int argc, char* argv[])
{
	int iRet;
	uint32 dVal = 0;
	uint16 dmode = 0;
	bool bValue = false;
	bool setValue = true;

 	printf("/*** Adam50XXDI Sample ***/ \n");
	printf("Select slotid: ");
	scanf("%d",&iSlot);

	iRet = OpenLib();
	if(iRet == Success)
	{
		//Get dio module values
		if((DIO_GetUniversalStatus(myprocHandle, iSlot, &dmode)) == Success)
		{
			printf("GetModes: %lx\n", dmode);

		}
		if((DI_GetValues(myprocHandle, iSlot, &dVal)) == Success)
		{
			printf("GetValues: %lx\n", dVal);
			bValue = ((dVal & (0x00000001<<iChannel)) > 0);
			if(bValue)
			{
				printf("Ch%d:True\n", iChannel);
				setValue = false;
			}
			else
			{
				printf("Ch%d:False\n", iChannel);
				setValue = true;
			}
			dVal = 0;

		}
		
		//else
		//	printf("GetValues() failed.");
	}
	else
		printf("OpenLib(%d) failed.\n", iRet);

	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}



