// GetSlotInfo.cpp : Defines the entry point for the application.
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../../../inc/bdaqadamio.h"

//Get the slot information of ADAM-5630

#define ADAM_SLOT_NUM	8
#define ADV_SUCCESS  0
#define MAX_ID_SIZE 12

pUSBMODENUM_INFO  usbenum_info[ ADAM_SLOT_NUM ];
int myprocHandle;
uint16 total_usbmodule = 0;
int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&myprocHandle) == ADV_SUCCESS)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle!=0)
		ADAMDrvClose(&myprocHandle);
}

void EX_GetSlotInfo()
{
	uint16 iSlot = 0;
	uint16 id = 0;
	char chSlotID[10];
	char byName[16];
	int index = 0;
	bool bExist = false;
	//GetSlotInformation
	for(iSlot = 0; iSlot < ADAM_SLOT_NUM;iSlot++)
	{
		index = 0;
		bExist = false;
		do{
			if( iSlot ==  usbenum_info[index]->usSlotId &&  usbenum_info[index]->ulModuleID != 0)
			{
				printf("Slot %d: %s\n", usbenum_info[index]->usSlotId, usbenum_info[index]->ucModuleName);
				bExist = true;
				free ( usbenum_info[index] );
				break;
			}
			index++;

		}while( index < total_usbmodule);

		if( !bExist )
		{
			if(SYS_GetModuleID(myprocHandle, iSlot, &id) == Success)
			{
				memset(chSlotID, 0 , 10);

				if(SYS_GetModuleName(myprocHandle, iSlot, byName) == Success)
				{
					snprintf(chSlotID, MAX_ID_SIZE, "%s",byName);
				}
				else
				{
					printf("Slot %d: Failed to get getModuleName.\n", iSlot);
				}
				printf("Slot %d: %s\n", iSlot, chSlotID);
			}
			else
			{
				printf("Slot %d: Failed to get.\n", iSlot);
			}
		}
	}
}

int main(int argc, char* argv[])
{
	int iRet;
 	printf("/*** GetSlotInfo Sample ***/ \n");
	uint16 nodeid = 0;

	iRet = OpenLib();
	if(iRet == Success)
	{
		iRet = SYS_EnumUSBModule( usbenum_info, &total_usbmodule );
		if( iRet == ErrorDriverNotFound )
			printf("No USB IO Module existed\n" );
		else if( iRet != Success)
			printf("Fail to enum USB IO Module\n" );

		if(SYS_GetNodeID(myprocHandle, &nodeid) == Success)
		{
			printf("Node ID:0x%X\n", nodeid);
		}
		else
			printf("Get Node ID Failed.\n");
		EX_GetSlotInfo();
	}
	else
		printf("OpenLib(%d) failed.\n", iRet);

	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}
