// Adam5080.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <stdlib.h>

#include "../../../inc/bdaqadamio.h"
#include "../../../inc/compatibility.h"

//////////////////////////////////////////////
//Take ADAM-5080 for example
//Get/Set Range, GetValues
 
//Note: You have to change the slot index
//////////////////////////////slot index
static uint16 iSlot = 1;
//////////////////////////////////////// 
static int iChannel = 0;
static int iDoChannel = 0;
uint32 iHiLimit,iLoLimit;
bool bHiEnable,bLoEnable;
uint16 iHiSlot,iHiChannel,iLoSlot,iLoChannel;

//////////////////////////////////////////////

static int handle;

int OpenLib()
{
	handle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&handle) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(handle!=0)
		ADAMDrvClose(&handle);
}

char * range2char(uint8 i_byRange)
{
	char *str = NULL;
	switch(i_byRange)
	{
	case 0:
		str = (char *)"Bi_Direction";
		break;
	case 1:
		str = (char *)"Up_Down";
		break;
	case 2:
		str = (char *)"Frequency";
		break;

	default:
		str = (char *) "Unknown";
		break;
	}

	return str;
}

static void showValue()
{
	uint32 ret=0;
	uint32 lVal;
	ret = CNT_GetValue(handle, iSlot, iChannel, &lVal);
	if( ret == Success)
	{
		printf("CNT_GetVale: \t\t%u\n", lVal);
	}else
	{
		printf("CNT_GetValue(ch%d) failed[%x].\n", iChannel,ret);
	}
}
static void showRange()
{
	uint32 ret=0;
	uint8 sVal = 0;
	ret = CNT_GetRange(handle, iSlot, iChannel, &sVal);
	if( ret == Success)
	{
		printf("CNT_GetRange: \t\t%u[ %s ]\n", sVal , range2char(sVal));

	}else
	{
		printf("CNT_GetRange(ch%d) failed[%x].\n", iChannel,ret);
	}
}
static void showFilter()
{
	uint32 ret=0;
	uint32 lVal;
	ret = CNT_GetFilter(handle, iSlot, &lVal);
	if( ret == Success)
	{
		printf("CNT_GetFilter: \t\t%u\n", lVal);
	}else
	{
		printf("CNT_GetFilter failed[%x].\n",ret);
	}
}
static void showStartup()
{
	uint32 ret=0;
	uint32 lVal;
	ret = CNT_GetStartup(handle, iSlot, iChannel, &lVal);
	if( ret == Success)
	{
		printf("CNT_GetStartup: \t%u\n", lVal);
	}else
	{
		printf("CNT_GetStartup(ch%d) failed[%x].\n", iChannel,ret);
	}
}
static void showState()
{
	uint32 ret=0;
	bool bVal;
	ret = CNT_GetState(handle, iSlot, iChannel, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetState: \t\t%u\n", bVal);
	}else
	{
		printf("CNT_GetState(ch%d) failed[%x].\n", iChannel,ret);
	}
}
static void showOverflow()
{
	uint32 ret=0;
	bool bVal;
	ret = CNT_GetOverflow(handle, iSlot, iChannel, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetOverflow: \t%u\n", bVal);
	}else
	{
		printf("CNT_GetOverflow(ch%d) failed[%x].\n", iChannel,ret);
	}
}

static void showRemoteAlarm(uint16 channel)
{
	uint32 ret=0;
	uint8 sVal;
	bool bVal;


	bool bHiFlag,bLoFlag;
	ret = CNT_GetRemoteAlarmFlag(handle, iSlot, channel, 1, &bHiFlag);
	if( ret != Success)
	{
		printf("CNT_GetRemoteAlarmFlag Hi(ch%d) failed[%x].\n", channel,ret);
	}
	ret = CNT_GetRemoteAlarmFlag(handle, iSlot, channel, 0, &bLoFlag);
	if( ret != Success)
	{
		printf("CNT_GetRemoteAlarmFlag Lo(ch%d) failed[%x].\n", channel,ret);
	}
	
	ret = CNT_GetRemoteAlarmEnable(handle, iSlot, channel, 1, &bHiEnable);
	if( ret != Success)
	{
		printf("CNT_GetRemoteHiAlarmEnable(ch%d) failed[%x].\n", channel,ret);
	}
	ret = CNT_GetRemoteAlarmEnable(handle, iSlot, channel, 0, &bLoEnable);
	if( ret != Success)
	{
		printf("CNT_GetRemoteHiAlarmEnable(ch%d) failed[%x].\n", channel,ret);
	}

	ret = CNT_GetRemoteAlarmMap(handle, iSlot, channel, 1, &iHiSlot, &iHiChannel);
	if( ret != Success)
	{
		printf("CNT_GetRemoteHiAlarmMap(ch%d) failed[%x].\n", channel,ret);
	}
	ret = CNT_GetRemoteAlarmMap(handle, iSlot, channel, 0, &iLoSlot,  &iLoChannel);
	if( ret != Success)
	{
		printf("CNT_GetRemoteHiAlarmMap(ch%d) failed[%x].\n", channel,ret);
	}

	ret = CNT_GetRemoteAlarmLimit(handle, iSlot, channel, 1, &iHiLimit);
	if( ret != Success)
	{
		printf("CNT_GetRemoteHiAlarmLimit(ch%d) failed[%x].\n", channel,ret);
	}
	ret = CNT_GetRemoteAlarmLimit(handle, iSlot, channel, 0, &iLoLimit);
	if( ret != Success)
	{
		printf("CNT_GetRemoteLoAlarmLimit(ch%d) failed[%x].\n", channel,ret);
	}
	printf("HiAlarm  %s\t%s\t%u\t%u\t %u\n",bHiEnable?"Enable":"Disable",bHiFlag?"Alarm":"Normal",iHiSlot,iHiChannel,iHiLimit);
	printf("LoAlarm  %s\t%s\t%u\t%u\t %u\n",bLoEnable?"Enable":"Disable",bLoFlag?"Alarm":"Normal",iLoSlot,iLoChannel,iLoLimit);
	return;
}

static void showStatus()
{
	uint32 ret=0;
	uint32 lVal;
	uint8  sVal;
	bool bVal;
	system("clear");
	printf("slot: \t%d\n" ,iSlot);
	printf("channel: %d\n",iChannel);
}

static int selectSlot()
{
	uint16 module_id = 0xff;
	int find = 0;
	int i = 0;
	for(i=0;i<8;i++)
	{
		SYS_GetModuleID(handle,i,&module_id);
		if(SYS_GetModuleID(handle,i,&module_id) == Success)
			printf("Slot: %2u ,Module ID: 0x%02x\n",i,module_id);
		if(module_id == 0x06 )
		{
			if(find == 0)
				iSlot = i;
			find++;
		}
	}

	if(find < 1)
	{
		printf("There is no ADAM5080\n");
		exit(0);
	}

	printf("Slot selected:\n");
	do
	{
		printf("Enter slot number:");
		scanf("%d",&iSlot);
		SYS_GetModuleID(handle,iSlot,&module_id);
		printf("Slot: %2u ,Module ID: 0x%02x\n",iSlot,module_id);
	}
	while(module_id != 0x06);
	return 0;
}

static int selectChannel()
{
	printf("channel selectd:%d\n",iChannel);
	do
	{
		printf("Enter channel number[0~3]:");
		scanf("%d",&iChannel);
		printf("Slot: %2u ,channel: %d\n",iSlot,iChannel);
	}
	while(iChannel < 0 || iChannel > 3);
	return 0;
}

static void clear_value()
{
	int ret = 0;
	uint32 lVal;
	printf("Clear slot:%d   channel:%d\n",iSlot,iChannel);
	ret = CNT_ClearValue(handle,iSlot,iChannel);
	if(ret == 0)
		printf("clear success\n");
	else
		printf("clear failed");

	ret = CNT_GetValue(handle, iSlot, iChannel, &lVal);
	if( ret == Success)
	{
		printf("CNT_GetVale: \t\t%u\n", lVal);
	}else
	{
		printf("CNT_GetValue(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void set_range()
{
	int ret = 0;
	int i,iVal;
	uint8 sVal;
	for(i = 0;i< 4;i++)
	{
		printf("%d):%s\n",i,range2char(i));
	}
	do
	{
		printf("Enter range number[0~6]:");
		scanf("%d",&iVal);
	}
	while(iVal < 0 || iVal > 6);
	ret = CNT_SetRange(handle,iSlot,iChannel,iVal);
	if(ret == Success)
		printf("set range success\n");
	else
		printf("set range failed");

	ret = CNT_GetRange(handle, iSlot, iChannel, &sVal);
	if( ret == Success)
	{
		printf("CNT_GetRange: \t\t%u[ %s ]\n", sVal , range2char(sVal));
	}
	else
	{
		printf("CNT_GetRange(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void set_filter()
{
	int ret = 0;
	uint32 i,iVal;
	do
	{
		printf("Enter filter value[8~65000]:");
		scanf("%d",&iVal);
	}
	while(iVal < 8 || iVal > 65000);
	ret = CNT_SetFilter(handle,iSlot,iVal);
	if(ret == 0)
		printf("set filter success\n");
	else
		printf("set filter failed");

	ret = CNT_GetFilter(handle, iSlot, &iVal);
	if( ret == Success)
	{
		printf("CNT_GetFilter: \t\t%u\n", iVal);
	}else
	{
		printf("CNT_GetFilter failed[%x].\n",ret);
	}
	return;
}

static void set_startup()
{
	int ret = 0;
	int i;
	unsigned int iVal;
	do
	{
		printf("Enter startup value[0~%u]:",0xffffffff);
		scanf("%u",&iVal);
	}
	while(0);
	ret = CNT_SetStartup(handle,iSlot,iChannel,iVal);
	if(ret == Success)
		printf("set startup success\n");
	else
		printf("set startup failed");

	ret = CNT_GetStartup(handle, iSlot, iChannel, &iVal);
	if( ret == Success)
	{
		printf("CNT_GetStartup: \t%u\n", iVal);
	}else
	{
		printf("CNT_GetStartup(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void set_state()
{
	int ret = 0;
	int i;
	unsigned int iVal;
	bool bVal;
	ret = CNT_GetState(handle, iSlot, iChannel, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetState: \t\t%u\n", bVal);
	}else
	{
		printf("CNT_GetState(ch%d) failed[%x].\n", iChannel,ret);
	}
	do
	{
		printf("Enter state value[0/1]:");
		scanf("%u",&iVal);
	}
	while(iVal < 0 || iVal > 1);
	ret = CNT_SetState(handle,iSlot,iChannel,iVal);
	if(ret == Success)
		printf("set state [%u] success\n",iVal);
	else
		printf("set state [%u] failed",iVal);

	ret = CNT_GetState(handle, iSlot, iChannel, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetState: \t\t%u\n", bVal);
	}else
	{
		printf("CNT_GetState(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void clear_overflow()
{
	int ret = 0;
	bool bVal;
	printf("Clear slot:%d   channel:%d\n",iSlot,iChannel);
	ret = CNT_ClearOverflow(handle,iSlot,iChannel);
	if(ret == Success)
		printf("clear success\n");
	else
		printf("clear failed");

	ret = CNT_GetOverflow(handle, iSlot, iChannel, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetOverflow: \t%u\n", bVal);
	}else
	{
		printf("CNT_GetOverflow(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void clear_remote_hi_alarm_flag()
{
	int ret = 0;
	bool bVal;
	printf("Clear slot:%d   channel:%d\n",iSlot,iChannel);
	ret = CNT_ClearRemoteAlarmFlag(handle,iSlot,iChannel,1);
	if(ret == 0)
		printf("clear success\n");
	else
		printf("clear failed\n");

	ret = CNT_GetRemoteAlarmFlag(handle, iSlot, iChannel, 1, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetRemoteHiAlarmFlag: \t%u\n", bVal);
	}else
	{
		printf("CNT_GetRemoteHiAlarmFlag(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}
static void clear_remote_lo_alarm_flag()
{
	int ret = 0;
	bool bVal;
	printf("Clear slot:%d   channel:%d\n",iSlot,iChannel);
	ret = CNT_ClearRemoteAlarmFlag(handle,iSlot,iChannel, 0);
	if(ret == 0)
		printf("clear success\n");
	else
		printf("clear failed");

	ret = CNT_GetRemoteAlarmFlag(handle, iSlot, iChannel, 0, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetRemoteHiAlarmFlag: \t%u\n", bVal);
	}else
	{
		printf("CNT_GetRemoteHiAlarmFlag(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}
static void clear_all_remote_alarm_flag()
{
	int ret = 0;
	ret = CNT_ClearRemoteAlarmFlag(handle,iSlot,iChannel, 1);
	if(ret == 0)
		printf("clear success\n");
	else
		printf("clear failed");
	ret = CNT_ClearRemoteAlarmFlag(handle,iSlot,iChannel, 0);
	if(ret == 0)
		printf("clear success\n");
	else
		printf("clear failed");

	return;
}

static void set_remote_hi_alarm_enable()
{
	int ret = 0;
	int i;
	unsigned int iVal;
	bool bVal;
	do
	{
		printf("Enter enable value[0/1]:");
		scanf("%u",&iVal);
	}
	while(iVal < 0 || iVal > 1);
	ret = CNT_SetRemoteAlarmEnable(handle,iSlot,iChannel,1,iVal);
	if(ret == Success)
		printf("CNT_SetRemoteHiAlarmEnable [%u] success\n",iVal);
	else
		printf("CNT_SetRemoteHiAlarmEnable [%u] failed",iVal);

	ret = CNT_GetRemoteAlarmEnable(handle, iSlot, iChannel, 1,&bVal);
	if( ret == Success)
	{
		printf("CNT_GetRemoteHiAlarmEnable: \t%u\n", bVal);
	}else
	{
		printf("CNT_GetRemoteHiAlarmEnable(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}
static void set_remote_lo_alarm_enable()
{
	int ret = 0;
	int i;
	unsigned int iVal;
	bool bVal;
	do
	{
		printf("Enter state value[0/1]:");
		scanf("%u",&iVal);
	}
	while(iVal < 0 || iVal > 1);
	ret = CNT_SetRemoteAlarmEnable(handle,iSlot,iChannel,0,iVal);
	if(ret == 0)
		printf("CNT_SetRemoteLoAlarmEnable [%u] success\n",iVal);
	else
		printf("CNT_SetRemoteLoAlarmEnable [%u] failed",iVal);

	ret = CNT_GetRemoteAlarmEnable(handle, iSlot, iChannel, 0, &bVal);
	if( ret == Success)
	{
		printf("CNT_GetRemoteLoAlarmEnable: \t%u\n", bVal);
	}else
	{
		printf("CNT_GetRemoteLoAlarmEnable(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void set_remote_hi_alarm_map()
{
	int ret = 0;
	int i;
	unsigned short slot;
	unsigned short channel;
	uint8 sVal;
	do
	{
		printf("Enter alarm map slot value[0~7]:");
		scanf("%hd",&slot);
	}
	while(slot < 0 || slot > 7);
	do
	{
		printf("Enter alarm map channel value[0~7]:");
		scanf("%hd",&channel);
	}
	while(channel < 0 || channel > 7);
	ret = CNT_SetRemoteAlarmMap(handle,iSlot,iChannel,1,slot,channel);
	if(ret == Success)
		printf("set alarm map [%u,%u] success\n" ,slot,channel);
	else
		printf("set alarm map failed\n");

	ret = CNT_GetRemoteAlarmMap(handle, iSlot, iChannel, 0, &slot,&channel);
	if( ret == Success)
	{
		printf("CNT_GetAlarmMap : \t%u,%u\n", slot,channel);
	}else
	{
		printf("CNT_GetAlarmMap(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}
static void set_remote_lo_alarm_map()
{
	int ret = 0;
	int i;
	unsigned short slot;
	unsigned short channel;
	uint8 sVal;
	do
	{
		printf("Enter alarm map slot value[0~7]:");
		scanf("%hd",&slot);
	}
	while(slot < 0 || slot > 7);
	do
	{
		printf("Enter alarm map channel value[0~7]:");
		scanf("%hd",&channel);
	}
	while(channel < 0 || channel > 7);
	ret = CNT_SetRemoteAlarmMap(handle,iSlot,iChannel,0,slot,channel);
	if(ret == Success)
		printf("CNT_SetRemoteLoAlarmMap [%u,%u] success\n" ,slot,channel);
	else
		printf("CNT_SetRemoteLoAlarmMap failed\n");

	ret = CNT_GetRemoteAlarmMap(handle, iSlot, iChannel, 0, &slot,&channel);
	if( ret == Success)
	{
		printf("CNT_GetRemoteLoAlarmMap : \t%u,%u\n", slot,channel);
	}else
	{
		printf("CNT_GetRemoteLoAlarmMap(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void set_remote_hi_alarm_limit()
{
	int ret = 0;
	int i;
	unsigned int iVal;
	do
	{
		printf("Enter alarm limit value:");
		scanf("%u",&iVal);
	}
	while(iVal < 0 );
	ret = CNT_SetRemoteAlarmLimit(handle,iSlot,iChannel,1,iVal);
	if(ret == Success)
		printf("set alarm  limit [%u] success\n",iVal);
	else
		printf("set alarm limit [%u] failed",iVal);

	ret = CNT_GetRemoteAlarmLimit(handle, iSlot, iChannel, 1,&iVal);
	if( ret == Success)
	{
		printf("CNT_GetAlarmLimit: \t%u\n", iVal);
	}else
	{
		printf("CNT_GetAlarmLimit(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static void set_remote_lo_alarm_limit()
{
	int ret = 0;
	int i;
	unsigned int iVal;
	do
	{
		printf("Enter alarm limit value:");
		scanf("%u",&iVal);
	}
	while(iVal < 0 );
	ret = CNT_SetRemoteAlarmLimit(handle,iSlot,iChannel,0,iVal);
	if(ret == Success)
		printf("set alarm  limit [%u] success\n",iVal);
	else
		printf("set alarm limit [%u] failed",iVal);

	ret = CNT_GetRemoteAlarmLimit(handle, iSlot, iChannel, 0, &iVal);
	if( ret == Success)
	{
		printf("CNT_GetAlarmLimit: \t%u\n", iVal);
	}else
	{
		printf("CNT_GetAlarmLimit(ch%d) failed[%x].\n", iChannel,ret);
	}
	return;
}

static int showRemoteAlarmMenu(int isClear)
{
	int max_item = 9;
	int value = 0;
	int ret = 0;
	if(isClear)
		system("clear");
	showRemoteAlarm(iChannel);
	printf("slot:%d   channel:%d\n",iSlot,iChannel);
	printf("0):back to Main\n");
	printf("1):clear high alarm flag\n");
	printf("2):clear low alarm flag\n");
	printf("3):set high alarm enable\n");
	printf("4):set low alarm enable\n");
	printf("5):set high alarm limit\n");
	printf("6):set low alarm limit\n");
	printf("7):set high alarm map\n");
	printf("8):set low alarm map\n");
	printf("9):clear all alarm\n");
	do{
		printf("enter item number[0~%d]:",max_item);
		scanf("%d",&value);
	}while(value < 0 || value > max_item);
	return value;
}

static void set_remote_alarm()
{
	do{
		int ret = showRemoteAlarmMenu(1);
		switch(ret)
		{
		case 0:
			goto err;
			break;
		case 1:
			clear_remote_hi_alarm_flag();
			break;
		case 2:
			clear_remote_lo_alarm_flag();
			break;
		case 3:
			set_remote_hi_alarm_enable();
			break;
		case 4:
			set_remote_lo_alarm_enable();
			break;
		case 5:
			set_remote_hi_alarm_limit();
			break;
		case 6:
			set_remote_lo_alarm_limit();
			break;
		case 7:
			set_remote_hi_alarm_map();
			break;
		case 8:
			set_remote_lo_alarm_map();
			break;
		case 9:
			clear_all_remote_alarm_flag();
			break;
		default:
			;
		}
	}while(1);

err:
	return;
}

static int showMenu(int isClear)
{
	int max_item = 11;
	int value = 0;
	int ret = 0;
	if(isClear)
		system("clear");

	printf("slot:%d   channel:%d\n",iSlot,iChannel);
	printf("0):exit\n");
	printf("1):fresh status\n");
	printf("2):select slot\n");
	printf("3):select channel\n");
	printf("4):set state\n");
	printf("5):set range\n");
	printf("6):set remote alarm\n");
	printf("7):clear value\n");
	printf("8):clear overflow\n");
	printf("9):set filter\n");
	printf("10):set startup\n");
	
	do{
		printf("enter item number[0~%d]:",max_item);
		scanf("%d",&value);
	}while(value < 0 || value > max_item);

	return value;
}

void freshStatus()
{
	do{
		system("clear");
		printf("slot: \t%d\n" ,iSlot);
		printf("channel: %d\n",iChannel);

		showValue();
		showState();

		showOverflow();
		showRemoteAlarm(iChannel);
		printf("\nPress Enter back to maim menu\n");
		sleep(2);
	} while(!kbhit());
}

int main(int argc, char* argv[])
{
	int iRet;
	bool bValue = false;
	bool setValue = true;

	system("clear");
 	printf("/*** Adam5080 Util ***/ \n");

	iRet = OpenLib();
	if(iRet != Success)
	{
		printf("OpenLib(%d) failed.\n", iRet);
		return 0;
	}
	selectSlot();
	showStatus();
	do{
		int ret = showMenu(0);
		switch(ret)
		{
		case 0:
			goto err;
			break;
		case 1:
			freshStatus();
			break;
		case 2:
			selectSlot();
			break;
		case 3:
			selectChannel();
			break;
		case 4:
			set_state();
			break;
		case 5:
			set_range();
			break;
		case 6:
			set_remote_alarm();
			break;
		case 7:
			clear_value();
			break;
		case 8:
			clear_overflow();
			break;
		case 9:
			set_filter();
			break;
		case 10:
			set_startup();
			break;
		default:
			;
		}
	}while(1);

err:
	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}
