// AdamAIread.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <stdlib.h>

#include "../../../inc/bdaqadamio.h"
#include "../../../inc/compatibility.h"


//////////////////////////////////////////////

//Get/Set Range, Get/Set ChannelEnable, GetValues

//Note: You have mark the module definition or change slot index

//////////////////////////////slot index
uint16 iSlot = 0; 
////////////////////////////////////////
uint16 module_id = 0xff;
char module_name[16];
uint16 m_iChTotal = 0;
uint32 uRange = 0;

//////////////////////////////////////////////

int ADV_SUCCESS = 0;

int myprocHandle;

int OpenLib()
{
	myprocHandle = 0;

	//OpenDeviceLib
	if(ADAMDrvOpen(&myprocHandle) == Success)
		return Success;
	else
		return -99;
}

void CloseLib()
{
	//Close device library
	if(myprocHandle!=0)
		ADAMDrvClose(&myprocHandle);
}

char * range2char(uint8 i_byRange)
{
	char *str = NULL;
	switch(i_byRange)
	{
	case V_Neg10To10:
		str = (char *)"V_Neg10To10";
		break;
	case V_Neg5To5:
		str = (char *)"V_Neg5To5";
		break;
	case V_Neg2pt5To2pt5:
		str = (char *)"V_Neg2pt5To2pt5";
		break;
	case V_Neg1To1:
		str = (char *)"V_Neg1To1";
		break;	
	case mV_Neg500To500:
		str = (char *)"mV_Neg500To500";
		break;	
	case mV_Neg150To150:
		str = (char *)"mV_Neg150To150";
		break;
	case mA_Neg20To20:
		str = (char *)"mA_Neg20To20";
		break;	
	case mA_4To20:
		str = (char *)"mA_4To20";
		break;	
	case V_0To2pt5:
		str = (char *)"V_0To2pt5";
		break;			
	case V_0To5:
		str = (char *)"V_0To5";
		break;		
	case V_0To10:
		str = (char *)"V_0To10";
		break;	

	case V_0To1:
		str = (char *)"V_0To1";
		break;	
	case V_0To15:
		str = (char *)"V_0To15";
		break;	
	case V_Neg15To15:
		str = (char *)"V_Neg15To15";
		break;
	case mV_0To500:
		str = (char *)"mV_0To500";
		break;
	case mV_0To150:
		str = (char *)"mV_0To150";
		break;
	case mA_0To20:
		str = (char *)"mA_0To20";
		break;	

		
    //5013
	case Pt385_Neg100To100:
		str = (char *)"Pt100(385)_Neg100To100";
		break;	

	case Pt385_0To100:
		str = (char *)"Pt100(385)_0To100";
		break;	

	case Pt385_0To200:
		str = (char *)"Pt100(385)_0To200";
		break;	

	case Pt385_0To600:
		str = (char *)"Pt100(385)_0To600";
		break;	

	case Pt392_Neg100To100:
		str = (char *)"Pt100(3916)_Neg100To100";
		break;	

	case Pt392_0To100:
		str = (char *)"Pt100(3916)_0To100";
		break;	
	case Pt392_0To200:
		str = (char *)"Pt100(3916)_0To200";
		break;	

	case Pt392_0To600:
		str = (char *)"Pt100(3916)_0To600";
		break;	

	case Ni518_Neg80To100:
		str = (char *)"Ni(672)_Neg80To100";
		break;	

	case Ni518_0To100:
		str = (char *)"Ni(618)_0To100";
		break;	
    //5018

	case mV_Neg15To15:
		str = (char *)"mV_Neg15To15";
		break;	


	case mV_Neg50To50:
		str = (char *)"mV_Neg50To50";
		break;	

	case mV_Neg100To100:
		str = (char *)"mV_Neg100To100";
		break;	

	case Jtype_0To760C:
		str = (char *)"Jtype_0To760C";
		break;	
		
	case Ktype_0To1370C:
		str = (char *)"Ktype_0To1370C";
		break;	
	
	case Ttype_Neg100To400C:
		str = (char *)"Ttype_Neg100To400C";
		break;	
	case Etype_0To1000C:
		str = (char *)"Etype_0To1000C";
		break;	
	case Rtype_500To1750C:
		str = (char *)"Rtype_500To1750C";
		break;

	case Stype_500To1750C:
		str = (char *)"Stype_500To1750C";
		break;
	case Btype_500To1800C:
		str = (char *)"Btype_500To1800C";
		break;



	default:
		str = (char *) "Unknown";
		break;
	}

	return str;
}

void set5013Ranges()
{
	printf("%d):%s\n",Pt385_Neg100To100,range2char(Pt385_Neg100To100));
	printf("%d):%s\n",Pt385_0To100,range2char(Pt385_0To100));
	printf("%d):%s\n",Pt385_0To200,range2char(Pt385_0To200));
	printf("%d):%s\n",Pt385_0To600,range2char(Pt385_0To600));
	printf("%d):%s\n",Pt392_Neg100To100,range2char(Pt392_Neg100To100));
	printf("%d):%s\n",Pt392_0To100,range2char(Pt392_0To100));
	printf("%d):%s\n",Pt392_0To200,range2char(Pt392_0To200));
	printf("%d):%s\n",Pt392_0To600,range2char(Pt392_0To600));
	printf("%d):%s\n",Ni518_Neg80To100,range2char(Ni518_Neg80To100));
	printf("%d):%s\n",Ni518_0To100,range2char(Ni518_0To100));

	printf("Enter range number:");
	scanf("%d",&uRange);

}

void set5017Ranges()
{

	printf("%d):%s\n",V_Neg10To10,range2char(V_Neg10To10));
	printf("%d):%s\n",V_Neg5To5,range2char(V_Neg5To5));
	printf("%d):%s\n",V_Neg1To1,range2char(V_Neg1To1));
	printf("%d):%s\n",mV_Neg500To500,range2char(mV_Neg500To500));
	printf("%d):%s\n",mV_Neg150To150,range2char(mV_Neg150To150));
	
	printf("%d):%s\n",mA_Neg20To20,range2char(mA_Neg20To20));
	printf("%d):%s\n",mA_4To20,range2char(mA_4To20));

	printf("Enter range number:");
	scanf("%d",&uRange);

}
void set5018Ranges()
{
	printf("%d):%s\n",mV_Neg15To15,range2char(mV_Neg15To15));
	printf("%d):%s\n",mV_Neg50To50,range2char(mV_Neg50To50));
	printf("%d):%s\n",mV_Neg100To100,range2char(mV_Neg100To100));
	printf("%d):%s\n",mV_Neg500To500,range2char(mV_Neg500To500));
	printf("%d):%s\n",V_Neg1To1,range2char(V_Neg1To1));
	printf("%d):%s\n",V_Neg2pt5To2pt5,range2char(V_Neg2pt5To2pt5));
	printf("%d):%s\n",mA_Neg20To20,range2char(mA_Neg20To20));

	printf("%d):%s\n",Jtype_0To760C,range2char(Jtype_0To760C));
	printf("%d):%s\n",Ktype_0To1370C,range2char(Ktype_0To1370C));
	printf("%d):%s\n",Ttype_Neg100To400C,range2char(Ttype_Neg100To400C));
	printf("%d):%s\n",Etype_0To1000C,range2char(Etype_0To1000C));
	printf("%d):%s\n",Rtype_500To1750C,range2char(Rtype_500To1750C));
	printf("%d):%s\n",Stype_500To1750C,range2char(Stype_500To1750C));
	printf("%d):%s\n",Btype_500To1800C,range2char(Btype_500To1800C));	

	printf("Enter range number:");
	scanf("%d",&uRange);

}

void set5017HRanges()
{
	printf("%d):%s\n",V_Neg10To10,range2char(V_Neg10To10));
	printf("%d):%s\n",V_0To10,range2char(V_0To10));	
	printf("%d):%s\n",V_Neg5To5,range2char(V_Neg5To5));
	printf("%d):%s\n",V_0To5,range2char(V_0To5));	
	printf("%d):%s\n",V_Neg2pt5To2pt5,range2char(V_Neg2pt5To2pt5));
	printf("%d):%s\n",V_0To2pt5,range2char(V_0To2pt5));
	printf("%d):%s\n",V_Neg1To1,range2char(V_Neg1To1));
	printf("%d):%s\n",V_0To1,range2char(V_0To1));	
	printf("%d):%s\n",mV_Neg500To500,range2char(mV_Neg500To500));
	printf("%d):%s\n",mV_0To500,range2char(mV_0To500));
	
	printf("%d):%s\n",mA_Neg20To20,range2char(mA_Neg20To20));
	printf("%d):%s\n",mA_4To20,range2char(mA_4To20));

	printf("Enter range number:");
	scanf("%d",&uRange);

}
void set5017UHRanges()
{

	printf("%d):%s\n",V_Neg10To10,range2char(V_Neg10To10));
	printf("%d):%s\n",V_0To10,range2char(V_0To10));	
	printf("%d):%s\n",mV_0To500,range2char(mV_0To500));
	
	printf("%d):%s\n",mA_0To20,range2char(mA_0To20));
	printf("%d):%s\n",mA_4To20,range2char(mA_4To20));

	printf("Enter range number:");
	scanf("%d",&uRange);

}
void set5017PRanges()
{


	printf("%d):%s\n",V_Neg10To10,range2char(V_Neg10To10));
	printf("%d):%s\n",V_Neg5To5,range2char(V_Neg5To5));
	printf("%d):%s\n",V_Neg1To1,range2char(V_Neg1To1));
	printf("%d):%s\n",mV_Neg500To500,range2char(mV_Neg500To500));
	printf("%d):%s\n",mV_Neg150To150,range2char(mV_Neg150To150));
	printf("%d):%s\n",mA_Neg20To20,range2char(mA_Neg20To20));
	printf("%d):%s\n",mA_4To20,range2char(mA_4To20));
	
	printf("%d):%s\n",V_Neg15To15,range2char(V_Neg15To15));
	printf("%d):%s\n",V_0To10,range2char(V_0To10));	
	printf("%d):%s\n",V_0To5,range2char(V_0To5));
	printf("%d):%s\n",V_0To1,range2char(V_0To1));	
	printf("%d):%s\n",mV_0To500,range2char(mV_0To500));
	printf("%d):%s\n",mV_0To500,range2char(mV_0To150));
	printf("%d):%s\n",mA_0To20,range2char(mA_0To20));
	printf("%d):%s\n",V_0To15,range2char(V_0To15));	

	printf("Enter range number:");
	scanf("%d",&uRange);

}

void set5018PRanges()
{

	printf("%d):%s\n",mV_Neg15To15,range2char(mV_Neg15To15));
	printf("%d):%s\n",mV_Neg50To50,range2char(mV_Neg50To50));
	printf("%d):%s\n",mV_Neg100To100,range2char(mV_Neg100To100));
	printf("%d):%s\n",mV_Neg500To500,range2char(mV_Neg500To500));
	printf("%d):%s\n",V_Neg1To1,range2char(V_Neg1To1));
	printf("%d):%s\n",V_Neg2pt5To2pt5,range2char(V_Neg2pt5To2pt5));
	printf("%d):%s\n",mA_Neg20To20,range2char(mA_Neg20To20));
	printf("%d):%s\n",mA_Neg20To20,range2char(mA_4To20));

	printf("%d):%s\n",Jtype_0To760C,range2char(Jtype_0To760C));
	printf("%d):%s\n",Ktype_0To1370C,range2char(Ktype_0To1370C));
	printf("%d):%s\n",Ttype_Neg100To400C,range2char(Ttype_Neg100To400C));
	printf("%d):%s\n",Etype_0To1000C,range2char(Etype_0To1000C));
	printf("%d):%s\n",Rtype_500To1750C,range2char(Rtype_500To1750C));
	printf("%d):%s\n",Stype_500To1750C,range2char(Stype_500To1750C));
	printf("%d):%s\n",Btype_500To1800C,range2char(Btype_500To1800C));	

	printf("Enter range number:");
	scanf("%d",&uRange);

}

static int selectSlot()
{
	uint32 ret=0;
	int find = 0;
	int i = 0;
	for(i=0;i<8;i++)
	{
		if(SYS_GetModuleID(myprocHandle,i,&module_id) == Success)
			if(SYS_GetModuleName(myprocHandle, i, module_name) == Success)
				printf("Slot: %2u ,Module ID: 0x%02x,Module Name: %s\n",i,module_id,module_name);


		if( module_id == 0x04||
			module_id == 0x05||
			module_id == 0x08||
			module_id == 0x09||
			module_id == 0x0C||
			module_id == 0x17||
			module_id == 0x0D||
			module_id == 0x38)
		{
			if(find == 0)
				iSlot = i;
			find++;
		}
	}

	if(find < 1)
	{
		printf("There is no AI module\n");
		exit(0);
	}

	printf("Slot selected:\n");
	do
	{
		printf("Enter slot number:");
		scanf("%d",&iSlot);
		SYS_GetModuleID(myprocHandle,iSlot,&module_id);
		printf("Slot: %2u ,Module ID: 0x%02x\n",iSlot,module_id);
		
		AI_GetChannelTotal(myprocHandle, iSlot, &m_iChTotal); 
		if( ret == ADV_SUCCESS)
		{
			printf("AI_GetChannelTotal: \t\t%u\n", m_iChTotal);

		}
		else
		{
			printf("AI_GetChannelTotal failed[%x].\n", ret);

		}
	}
	while(module_id != 0x04&&module_id != 0x05&&module_id != 0x08&& module_id != 0x09&&
		  module_id != 0x0C&&module_id != 0x17&&module_id != 0x0D&& module_id != 0x38);
	return 0;
}

static void setChEnable()
{
	bool bChEnabled[16] = {0};
	int en = 0;
	int iChannel=0;
	
	do
	{
		printf("Choose channel [0~%d]:", m_iChTotal-1);
		scanf("%d",&iChannel);
		printf("Slot: %2u ,channel: %d\n",iSlot,iChannel);
	}
	while(iChannel < 0 || iChannel > (m_iChTotal-1));

	if(AI_GetChannelEnabled(myprocHandle, iSlot, bChEnabled) == Success)
	{
	
		printf("enable or disable:");
		scanf("%d",&en);
		bChEnabled[iChannel] = (bool)en;
					
		if(AI_SetChannelEnabled(myprocHandle, iSlot, bChEnabled) == Success)
		{

			printf("AI_SetChannelEnabled(ch%d) : \t\t%d\n", iChannel, bChEnabled[iChannel]);
			
		}
		else
		{
			printf("AI_SetChannelEnabled failed.\n");
		}	
	}


}

void setRanges()
{
	uint32 ret=0;
	uint16 iChannel = 0;
	char module_name[16] ;
	do
	{
		printf("Enter channel number[0~%d]:",m_iChTotal -1);
		scanf("%d",&iChannel);
		printf("Slot: %2u ,channel: %d\n",iSlot,iChannel);
	}
	while(iChannel < 0 || iChannel > (m_iChTotal -1));
	
	ret = SYS_GetModuleID(myprocHandle,iSlot,&module_id);
	if(ret != Success)
	{
		printf("SYS_GetModuleID failed.\n");
		return;
	}
	switch(module_id)
	{
		case 0x04://MODULEID_5017
			set5017Ranges();

			break;
		case 0x05://MODULEID_5018
			set5018Ranges();
			break;
			
		case 0x08://MODULEID_5013A MODULEID_5013B
		case 0x09:
			set5013Ranges();
			break;
			
		case 0x0C://MODULEID_5017H
			set5017HRanges();
			break;
			
		case 0x17://MODULEID_5017UH
			set5017UHRanges();
			break;
		case 0x0D://MODULEID_5018H
			break;
			
		case 0x38://MODULEID_5018P MODULEID_5017P
			
			ret = SYS_GetModuleName(myprocHandle, iSlot, module_name);
			if(ret != Success)
			{
				printf("SYS_GetModuleID failed.\n");
				return;
			}
			if(!strcmp(module_name, "ADAM5018P"))
				set5018PRanges();
			else			
				set5017PRanges();
			break;

		default:
			break;
			
	}
		
	if(AI_SetInputRange(myprocHandle, iSlot, iChannel, uRange) == Success)
		printf("AI_SetInputRange done.\n");
	else
		printf("AI_SetInputRange failed.\n");
	
}

static void showChEnable()
{
	bool bChEnabled[16] = {0};
	int iChannel=0;
	if(AI_GetChannelEnabled(myprocHandle, iSlot, bChEnabled) == ADV_SUCCESS)
	{
		for(iChannel=0;iChannel<m_iChTotal;iChannel++)
		{
			printf("AI_GetChannelEnabled(%d): \t\t%d\n", iChannel, bChEnabled[iChannel]);
		}
	}
	else
	{
		printf("AI_GetChannelEnabled failed.\n");
	}
}

static void showValue()
{
	uint32 ret=0;
	//double fVal = 0.0;
	int iChannel = 0;
	double* fVal = NULL;
	uint16* raw = NULL;
	
	fVal = (double*)malloc(m_iChTotal * sizeof(double));
	raw =  (uint16*)malloc(m_iChTotal * sizeof(uint16));
	//for(iChannel = 0; iChannel < 2; iChannel++)
	{
		ret = AI_GetValues(myprocHandle, iSlot, raw, fVal);
		
		if( ret == Success)
		{
			
			for( iChannel = 0; iChannel < m_iChTotal; iChannel++)
			{
				printf("AI_GetValue(ch%d)\t\t%f\t\t0x%X\n",iChannel,fVal[iChannel],raw[iChannel]);
			}
		}
		else
		{
				printf("AI_GetValues(ch%d) failed[%x].\n", iChannel,ret);
			
		}
	}
}

static void showRange()
{
	uint32 ret=0;
	uint32 sVal;
	int iChannel = 0;
	
	for( iChannel = 0; iChannel < m_iChTotal; iChannel++)
	{
		ret = AI_GetInputRange(myprocHandle, iSlot, iChannel, &sVal);
		if( ret == Success)
		{
			printf("AI_GetInputRange(ch%d): \t\t%u[ %s ]\n",iChannel,sVal , range2char(sVal));	

		}else
		{
			printf("AI_GetInputRange(ch%d) failed[%x].\n", iChannel,ret);
		}
	}
}

static void showIntegrationTime()
{
	uint16  IntegrationTime = 0;
	uint32 ret = 0;
	
	ret = AI_GetRangeIntegrationTime(myprocHandle, iSlot, &IntegrationTime);
	if( ret == ADV_SUCCESS )
	{
		printf("AI_GetRangeIntegrationTime: \t\t%s\n",(IntegrationTime == 1 ? "50 Hz" : "60 Hz" ));
	}
	else
	{
		printf("AI_GetRangeIntegrationTime failed.ret = 0x%X\n",ret);
	}

}

static void showStatus()
{
	uint32 ret=0;
	uint32 lVal;
	uint8  sVal;
	bool bVal;

	printf("slot: \t%d\n" ,iSlot);

	showChEnable();
	showRange();
	showIntegrationTime();
	showValue();
}
static int showMenu(int isClear)
{
	int max_item = 3;
	int value = 0;
	int ret = 0;
	if(isClear)
		system("clear");

	printf("slot:%d \n",iSlot);
	printf("0):exit\n");
	printf("1):set range\n");
	printf("2):set enable\n");
	printf("3):display data\n");

	do{
		printf("enter item number[0~%d]:",max_item);
		scanf("%d",&value);
	}while(value < 0 || value > max_item);

	return value;
}

int main(int argc, char* argv[])
{
	int iRet;
	bool bValue = false;
	bool setValue = true;
	uint16 i_ch = 0;
	
 	printf("/*** Adam AI module Sample ***/ \n");

	iRet = OpenLib();
	if(iRet != Success)
	{
		printf("OpenLib(%d) failed.\n", iRet);
		return 0;
	}
	selectSlot();
	showStatus();
	do{
		int ret = showMenu(0);
		
		switch(ret)
		{
		case 0:
			goto err;
			break;
		case 1:
			setRanges();
			showRange();
			break;
		case 2:
			setChEnable();
			showChEnable();
			break;
		case 3:
			do{
			showValue();		
			printf("\nPress Enter back to maim menu\n");
			sleep(1);
			system("clear");}while(!kbhit());
			break;

		default:
			break;
		}
	}while(1);

err:

	CloseLib();
	printf("/***        END         ***/ \n");
	getchar();
	return 0;
}

